const inquirer = require("inquirer");
const fs = require("fs-extra");

/**
 * 1. 开始开发 -> 选择环境
 * 2. 切换环境
 * 3. 上传代码 -> 选择环境 -> 输入描述和版本号
 * 4. 预览 -> 选择页面
 * 5. 自动预览
 * 6. 查看当前项目信息
 * 7. 注册cli
 */

module.exports = {
  async runPrompts() {
    const prompts = [
      { value: "start", name: "开始开发" },
      { value: "togger", name: "切换环境" },
      { value: "upload", name: "上传代码" },
      { value: "preview", name: "预览" },
      { value: "autoPreview", name: "自动预览" },
      { value: "info", name: "查看当前项目信息" },
      { value: "initCli", name: "注册cli" }
    ];

    const result = await inquirer.prompt({
      type: "list",
      name: "command",
      message: "请选择一个功能",
      choices: prompts
    });

    return result.command;
  },
  async runToggleEnv(env) {
    const result = await inquirer.prompt({
      type: "list",
      name: "command",
      message: "请选择一个环境",
      choices: env
    });
    return result.command;
  },
  async runTogglePage(page) {
    const result = await inquirer.prompt({
      type: "list",
      name: "command",
      message: "请选择一个页面",
      choices: page
    });
    return result.command;
  },
  async runSetDescriptionAndVersion() {
    let result = await inquirer.prompt([
      {
        type: "input",
        name: "v",
        message: "请输入版本号"
      },
      {
        type: "input",
        name: "des",
        message: "请输入描述"
      }
    ]);
    return result;
  },
  async runInitCli() {
    let result = await inquirer.prompt({
      type: "input",
      name: "command",
      message: "请输入最新的CLI地址",
      validate(val) {
        return fs.pathExistsSync(val) || `输入的地址不存在`;
      }
    });
    return result.command;
  }
};
